## CdProfile

CdProfile — Client object for accessing information about colord profiles

## Functions

GQuark | cd_profile_error_quark ()
CdProfile * | cd_profile_new ()
CdProfile * | cd_profile_new_with_object_path ()
void | cd_profile_connect ()
gboolean | cd_profile_connect_finish ()
void | cd_profile_set_property ()
gboolean | cd_profile_set_property_finish ()
void | cd_profile_install_system_wide ()
gboolean | cd_profile_install_system_wide_finish ()
const gchar * | cd_profile_get_id ()
const gchar * | cd_profile_get_filename ()
const gchar * | cd_profile_get_qualifier ()
const gchar * | cd_profile_get_format ()
const gchar * | cd_profile_get_title ()
const gchar * | cd_profile_get_object_path ()
CdProfileKind | cd_profile_get_kind ()
CdColorspace | cd_profile_get_colorspace ()
CdObjectScope | cd_profile_get_scope ()
guint | cd_profile_get_owner ()
gchar ** | cd_profile_get_warnings ()
gint64 | cd_profile_get_created ()
gint64 | cd_profile_get_age ()
gboolean | cd_profile_get_has_vcgt ()
gboolean | cd_profile_get_is_system_wide ()
GHashTable * | cd_profile_get_metadata ()
const gchar * | cd_profile_get_metadata_item ()
void | cd_profile_set_object_path ()
gboolean | cd_profile_get_connected ()
gchar * | cd_profile_to_string ()
gboolean | cd_profile_equal ()
gboolean | cd_profile_has_access ()
CdIcc * | cd_profile_load_icc ()

## Types and Values

#define | CD_PROFILE_ERROR
#define | CD_PROFILE_TYPE_ERROR
#define | CD_TYPE_PROFILE
struct | CdProfileClass
| CdProfile

## Description

A helper GObject to use for accessing colord profiles, and to be notified when it is changed.

See also: CdClient

## Functions

### cd_profile_error_quark ()

    GQuark
    cd_profile_error_quark (void);

#### Returns

An error quark.

Since: 0.1.0

### cd_profile_new ()

    CdProfile *
    cd_profile_new (void);

Creates a new CdProfile object.

#### Returns

a new CdProfile object.

Since: 0.1.0

### cd_profile_new_with_object_path ()

    CdProfile *
    cd_profile_new_with_object_path (const gchar *object_path);

Creates a new CdProfile object with a known object path.

#### Parameters

object_path | The colord object path. |

#### Returns

a new profile object.

Since: 0.1.8

### cd_profile_connect ()

    void
    cd_profile_connect (CdProfile *profile,
                        GCancellable *cancellable,
                        GAsyncReadyCallback callback,
                        gpointer user_data);

Connects to the object and fills up initial properties.

#### Parameters

profile | a CdProfile instance. |
cancellable | a GCancellable, or `NULL` |
callback | the function to run on completion |
user_data | the data to pass to `callback` |

Since: 0.1.8

### cd_profile_connect_finish ()

    gboolean
    cd_profile_connect_finish (CdProfile *profile,
                               GAsyncResult *res,
                               GError **error);

Gets the result from the asynchronous function.

#### Parameters

profile | a CdProfile instance. |
res | the GAsyncResult |
error | A GError or `NULL` |

#### Returns

success

Since: 0.1.8

### cd_profile_set_property ()

    void
    cd_profile_set_property (CdProfile *profile,
                             const gchar *key,
                             const gchar *value,
                             GCancellable *cancellable,
                             GAsyncReadyCallback callback,
                             gpointer user_data);

Deletes a color device.

#### Parameters

profile | a CdProfile instance. |
key | a key name |
value | a key value |
cancellable | a GCancellable, or `NULL` |
callback | the function to run on completion |
user_data | the data to pass to `callback` |

Since: 0.1.8

### cd_profile_set_property_finish ()

    gboolean
    cd_profile_set_property_finish (CdProfile *profile,
                                    GAsyncResult *res,
                                    GError **error);

Gets the result from the asynchronous function.

#### Parameters

profile | a CdProfile instance. |
res | the GAsyncResult |
error | A GError or `NULL` |

#### Returns

success

Since: 0.1.8

### cd_profile_install_system_wide ()

    void
    cd_profile_install_system_wide (CdProfile *profile,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Sets the profile system wide.

#### Parameters

profile | a CdProfile instance. |
cancellable | a GCancellable, or `NULL` |
callback | the function to run on completion |
user_data | the data to pass to `callback` |

Since: 0.1.8

### cd_profile_install_system_wide_finish ()

    gboolean
    cd_profile_install_system_wide_finish (CdProfile *profile,
                                           GAsyncResult *res,
                                           GError **error);

Gets the result from the asynchronous function.

#### Parameters

profile | a CdProfile instance. |
res | the GAsyncResult |
error | A GError or `NULL` |

#### Returns

success

Since: 0.1.8

### cd_profile_get_id ()

    const gchar *
    cd_profile_get_id (CdProfile *profile);

Gets the profile ID.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A string, or `NULL` for invalid

Since: 0.1.0

### cd_profile_get_filename ()

    const gchar *
    cd_profile_get_filename (CdProfile *profile);

Gets the profile filename.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A string, or `NULL` for invalid

Since: 0.1.0

### cd_profile_get_qualifier ()

    const gchar *
    cd_profile_get_qualifier (CdProfile *profile);

Gets the profile qualifier.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A string, or `NULL` for invalid

Since: 0.1.0

### cd_profile_get_format ()

    const gchar *
    cd_profile_get_format (CdProfile *profile);

Gets the profile format.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A string, or `NULL` for invalid

Since: 0.1.4

### cd_profile_get_title ()

    const gchar *
    cd_profile_get_title (CdProfile *profile);

Gets the profile title.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A string, or `NULL` for invalid

Since: 0.1.0

### cd_profile_get_object_path ()

    const gchar *
    cd_profile_get_object_path (CdProfile *profile);

Gets the object path for the profile.

#### Parameters

profile | a CdProfile instance. |

#### Returns

the object path, or `NULL`

Since: 0.1.0

### cd_profile_get_kind ()

    CdProfileKind
    cd_profile_get_kind (CdProfile *profile);

Gets the profile kind.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A CdProfileKind, e.g. `CD_PROFILE_KIND_DISPLAY_DEVICE`

Since: 0.1.1

### cd_profile_get_colorspace ()

    CdColorspace
    cd_profile_get_colorspace (CdProfile *profile);

Gets the profile colorspace.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A CdColorspace, e.g. `CD_COLORSPACE_RGB`

Since: 0.1.2

### cd_profile_get_scope ()

    CdObjectScope
    cd_profile_get_scope (CdProfile *profile);

Gets the profile scope.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A CdObjectScope, e.g. `CD_OBJECT_SCOPE_UNKNOWN`

Since: 0.1.10

### cd_profile_get_owner ()

    guint
    cd_profile_get_owner (CdProfile *profile);

Gets the profile owner.

#### Parameters

profile | a CdProfile instance. |

#### Returns

The UID of the user that created the device

Since: 0.1.13

### cd_profile_get_warnings ()

    gchar **
    cd_profile_get_warnings (CdProfile *profile);

Gets the profile warnings as a string array.

#### Parameters

profile | a CdProfile instance. |

#### Returns

Any profile warnings, e.g. "vcgt-non-monotonic".

[transfer none]

Since: 0.1.25

### cd_profile_get_created ()

    gint64
    cd_profile_get_created (CdProfile *profile);

Gets the profile created date and time.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A UNIX time, or 0 if the profile has no creation date

Since: 0.1.8

### cd_profile_get_age ()

    gint64
    cd_profile_get_age (CdProfile *profile);

Gets the profile age in seconds relative to the current time.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A UNIX time, or 0 if the profile has no creation date

Since: 0.1.8

### cd_profile_get_has_vcgt ()

    gboolean
    cd_profile_get_has_vcgt (CdProfile *profile);

Returns if the profile has a VCGT table.

#### Parameters

profile | a CdProfile instance. |

#### Returns

`TRUE` if VCGT is valid.

Since: 0.1.2

### cd_profile_get_is_system_wide ()

    gboolean
    cd_profile_get_is_system_wide (CdProfile *profile);

Returns if the profile is installed system wide and available for all users.

#### Parameters

profile | a CdProfile instance. |

#### Returns

`TRUE` if system wide.

Since: 0.1.2

### cd_profile_get_metadata ()

    GHashTable *
    cd_profile_get_metadata (CdProfile *profile);

Returns the profile metadata.

#### Parameters

profile | a CdProfile instance. |

#### Returns

a GHashTable.

[transfer container][element-type utf8 utf8]

Since: 0.1.2

### cd_profile_get_metadata_item ()

    const gchar *
    cd_profile_get_metadata_item (CdProfile *profile,
                                  const gchar *key);

Returns the profile metadata for a specific key.

#### Parameters

profile | a CdProfile instance. |
key | a key for the metadata dictionary |

#### Returns

the metadata value, or `NULL` if not set.

Since: 0.1.5

### cd_profile_set_object_path ()

    void
    cd_profile_set_object_path (CdProfile *profile,
                                const gchar *object_path);

Sets the object path of the profile.

#### Parameters

profile | a CdProfile instance. |
object_path | The colord object path. |

Since: 0.1.8

### cd_profile_get_connected ()

    gboolean
    cd_profile_get_connected (CdProfile *profile);

Gets if the profile has been connected.

#### Parameters

profile | a CdProfile instance. |

#### Returns

`TRUE` if properties are valid

Since: 0.1.9

### cd_profile_to_string ()

    gchar *
    cd_profile_to_string (CdProfile *profile);

Converts the profile to a string description.

#### Parameters

profile | a CdProfile instance. |

#### Returns

text representation of CdProfile

Since: 0.1.0

### cd_profile_equal ()

    gboolean
    cd_profile_equal (CdProfile *profile1,
                      CdProfile *profile2);

Tests two profiles for equality.

#### Parameters

profile1 | one CdProfile instance. |
profile2 | another CdProfile instance. |

#### Returns

`TRUE` if the profiles are the same device

Since: 0.1.8

### cd_profile_has_access ()

    gboolean
    cd_profile_has_access (CdProfile *profile);

Gets if the current user has access permissions to the profile.

#### Parameters

profile | a CdProfile instance. |

#### Returns

A string, or `NULL` for invalid

Since: 0.1.13

### cd_profile_load_icc ()

    CdIcc *
    cd_profile_load_icc (CdProfile *profile,
                         CdIccLoadFlags flags,
                         GCancellable *cancellable,
                         GError **error);

Loads a local ICC object from the abstract profile.

#### Parameters

profile | a CdProfile instance. |
flags | options for loading the profile |
cancellable | A GCancellable, or `NULL` |
error | A GError or `NULL` |

#### Returns

A new CdIcc object, or `NULL` for error.

[transfer full]

Since: 0.1.32

## Types and Values

### CD_PROFILE_ERROR

    #define CD_PROFILE_ERROR (cd_profile_error_quark ())

### CD_PROFILE_TYPE_ERROR

    #define CD_PROFILE_TYPE_ERROR (cd_profile_error_get_type ())

### CD_TYPE_PROFILE

    #define CD_TYPE_PROFILE (cd_profile_get_type ())

### struct CdProfileClass

    struct CdProfileClass {
    	GObjectClass		 parent_class;
    	void			(*changed)		(CdProfile		*profile);
    };

### CdProfile

    typedef struct _CdProfile CdProfile;